// Copyright (c) 2021 Dominic Masters
// 
// This software is released under the MIT License.
// https://opensource.org/licenses/MIT

#pragma once

// Static Libs
#include <glad/glad.h>// This will go eventually, this is just here to provide OpenGL Context
#include <duktape.h>
#include <cglm/cglm.h>
#include <stb_image.h>
#include <stb_truetype.h>

// Standard Libs
#include <stdio.h>
#include <stdint.h>
#include <stdbool.h>
#include <malloc.h>
#include <string.h>
#include <math.h>
#include <stdlib.h>

#if defined(_WIN32) || defined(_WIN64)
  // Windows Fixes
  # define strtok_r strtok_s
  # define sleep(n) _sleep(n)
  #include <windows.h>


  typedef HANDLE threadhandle_t;
  #define sysThreadCreate(mthd,otp,usr) otp=CreateThread(NULL,0,mthd,usr,0,NULL)
  #define sysThreadJoin(tp) WaitForSingleObject(tp, INFINITE)
  #define sysThreadCancel(tp,ec) TerminateThread(tp,ec)
#else
  // Unix Fixes
  #include <unistd.h>
  #include <pthread.h>
  #include <errno.h>

  typedef pthread_t threadhandle_t;
  #define sysThreadCreate(mthd,otp,usr) pthread_create(&otp,NULL,mthd,usr)
  #define sysThreadJoin(tp) pthread_join(tp, NULL)
  #define sysThreadCancel(tp,ec) pthread_cancel(tp)
#endif